<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\group_activity;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\group_activity\GroupActivityCategory;
use app\common\lists\ListsSearchInterface;


/**
 * 拼团活动分类列表
 * Class GroupActivityCategoryLists
 * @package app\adminapi\listsgroup_activity
 */
class GroupActivityCategoryLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function setSearch(): array
    {
        return [
            '=' => ['id', 'status','type', 'is_simulate_form','property_head_id'],
            '%like%' => ['title','area'],
        ];
    }
    public function queryWhere(){
        $where = [];
        if(!empty($this->params['area'])){
            $where[] = ['area', 'like', '%'.$this->params['area'].'%'];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function lists(): array
    {
        $list = GroupActivityCategory::with(['propertyHeadInfo'])
            ->where($this->searchWhere)
            ->field(['id', 'property_head_id','title', 'start_time', 'end_time', 'service_time', 'participant_num', 'type', 'form_time_limit', 'is_simulate_form', 'simulate_num','area','status','create_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
        
        foreach ($list as &$item) {
            $item['participant_num'] = $item['participant_num'] ? explode(',', $item['participant_num']) : [];
            $item['simulate_num'] = $item['simulate_num'] ? explode(',', $item['simulate_num']) : [];
            $item['area'] = $item['area'] ? explode(',', $item['area']) : [];
            $item['end_time'] = date('Y-m-d H:i:s', $item['end_time']);
        }
        return $list;
    }


    /**
     * @notes 获取拼团活动数量
     * @return int
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function count(): int
    {
        return GroupActivityCategory::where($this->searchWhere)->count();
    }

}